﻿/////////////////////////////////////////////////////////
// SkendPow effect
varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;

uniform lowp float pixelWidth;
uniform lowp float pixelHeight;
uniform lowp float Skend;
uniform lowp float Power;
uniform mediump vec2 pixelSize;
uniform mediump vec2 srcEnd;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
uniform mediump vec2 layoutStart;
uniform mediump vec2 layoutEnd;

void main(void)
{	
	mediump vec2 tex = vTex;
	mediump vec2 texOffset = tex - srcStart;
	
	// Original from C3 effect, did not work with sprite packing in C3
	// tex.y -= (pixelSize.x*Skend)*pow(tex.x,2.0);
	// Instead, calculate the normalised position n of vTex in the foreground rectangle and use that for Skend amount
	mediump vec2 n = (vTex - srcOriginStart) / (srcOriginEnd - srcOriginStart);
	tex.y -= (pixelSize.y*Skend)*pow(n.x,Power);
	tex = clamp(tex, srcOriginStart, srcOriginEnd);
		
	gl_FragColor = texture2D(samplerFront,tex);
}